C CGA.F77
C
C Primitives for CGA graphics
C
C Rev 00  28-Apr-88  JF    Based on C version
C

C Send the whole buffer to the display
      Subroutine CGA_Update
      Include 'Dos.Inc'
      Integer CGABuf (0:4095)
      Common /CGA_Common/ CGABuf
      Integer Display_Buffer_Address
      Data Display_Buffer_Address/X'B8000000'/
      Call F77_Block_to_Host (CGABuf, Display_Buffer_Address, 16354)
      End

C Set a video mode
      Subroutine Video_Mode (Mode)
      Integer Mode
      Include 'Dos.Inc'
      Include 'CGA.Inc'
      Integer CGABuf (0:4095)
      Common /CGA_Common/ CGABuf
      Integer I, DOSBlock (F77_DOS_Block_Size)
      Integer Video_Set_Mode, BIOS_Video_Driver
      Parameter (Video_Set_Mode=0, BIOS_Video_Driver=16)
      If (IAnd (Mode, Dont_Clear_Display) .eq. 0) then
         Do I = 0, 4095
            CGABuf (I) = 0
         End Do
      End If
      DosBlock (F77_DOS_AX) = IOr (IShft(Video_Set_Mode,8), Mode)
      Call F77_Host_Interrupt (BIOS_Video_Driver, .false., DOSBlock)
      End
         
C High-resolution plot
      Subroutine CGA_HiRes_Plot (X, Y)
      Integer X, Y
      Integer CGABuf (0:4095)
      Common /CGA_Common/ CGABuf
      Integer Offset, Bits, ByteShift
      Offset = IShft(X,-5) + (IShft(Y,-1)*20) + (IAnd(Y,1)*2048)
      Bits = IShft(1, 7-IAnd(X,7))
      ByteShift = IAnd(IShft(X,-3),3) * 8
      CGABuf (Offset) = IOr (CGABuf(Offset), IShft(Bits,ByteShift))
      End

C Low-resolution plot
      Subroutine CGA_LoRes_Plot (X, Y, Colour)
      Integer X, Y, Colour
      Integer CGABuf (0:4095)
      Common /CGA_Common/ CGABuf
      Integer Offset, Bits, ByteShift
      Offset = IShft(X,-4) + (IShft(Y,-1)*20) + (IAnd(Y,1)*2048)
      Bits = IShft(Colour, 6-(2*IAnd(X,3)))
      ByteShift = IAnd(IShft(X,-2),3) * 8
      CGABuf (Offset) = IOr (CGABuf(Offset), IShft(Bits,ByteShift))
      End

