C MANDELW.INC
C
C Parallel Fortran v. 2.0: Copyright (c) 1988 3L Ltd
C Example program: Mandelbrot set evaluation and display
C
C Worker task
C JF 10-May-88
C
C The application
C ---------------
C
C For details of the application in general, see the top of MANDELM.F77.
C
C Internals of MANDELW
C --------------------
C
C The task waits till a packet arrives.   This has the format defined
C in COMMAND.INC, and contains details of the portion of the Mandelbrot
C to do.   The task then does the work, and stores the results in the
C format defined in RESULTS.INC, which is then sent back to MANDELM.
C
      PROGRAM MANDELW
      IMPLICIT NONE
C
      INCLUDE 'NET.INC'
      INCLUDE 'COMMAND.INC'
      INCLUDE 'RESULTS.INC'
C
      INTEGER X, Y, COUNT, N
      REAL AC, BC, SIZE, A2, B2, A, B
      LOGICAL COMPLETE
C
100   CONTINUE
C
C        Task will wait here until packet arrives
         CALL F77_NET_RECEIVE (N, COMMAND, COMPLETE)
         N = 1
C        Scan the Y range... 
         DO Y = C_TLY, C_BRY
            BC = C_YCOORD - Y*C_GAP
C           ...and scan the X range, thus covering every point
            DO X = C_TLX, C_BRX
               AC = C_XCOORD + X*C_GAP
               A = AC
               B = BC
               SIZE = 0.0
               COUNT = 0
               A2 = A*A
               B2 = B*B
C              Do calculation till >2.0 away, or COUNT reaches 256
               DO WHILE ((SIZE .LT. 4.0) .AND. (COUNT .LT. 256))
                  B = 2.0*A*B + BC
                  A = A2 - B2 + AC
                  A2 = A*A
                  B2 = B*B
                  SIZE = A2 + B2
                  COUNT = COUNT+1
               END DO
C              Stored 0 means 1; stored 255 means 256
               R_COUNTS(N:N) = CHAR(COUNT-1)
               N = N+1
            END DO
         END DO
C        Send the top-left and bottom-right coordinates back in the
C        RESULTS packet too, so that the RECEIVE thread of MANDELM
C        can identify the packet.
         R_TLX = C_TLX
         R_TLY = C_TLY
         R_BRX = C_BRX
         R_BRY = C_BRY
         CALL F77_NET_SEND (1024, RESULTS, .TRUE.)
C
      GOTO 100
C
      END

